from enum import Enum


class PassageDirection(Enum):
    LEFT = "LEFT"
    RIGHT = "RIGHT"


class MultiModeInputMode(Enum):
    KEY_BEHAVIOR = "KEY_BEHAVIOR"
    SWITCH_BEHAVIOR = "SWITCH_BEHAVIOR"
    BINARY_BEHAVIOR = "BINARY_BEHAVIOR"


class BinaryBehaviorType(Enum):
    NORMALLY_CLOSE = "NORMALLY_CLOSE"
    NORMALLY_OPEN = "NORMALLY_OPEN"


class HeatingFailureValidationType(Enum):
    NO_HEATING_FAILURE = "NO_HEATING_FAILURE"
    HEATING_FAILURE_WARNING = "HEATING_FAILURE_WARNING"
    HEATING_FAILURE_ALARM = "HEATING_FAILURE_ALARM"


class HumidityValidationType(Enum):
    LESSER_LOWER_THRESHOLD = "LESSER_LOWER_THRESHOLD"
    GREATER_UPPER_THRESHOLD = "GREATER_UPPER_THRESHOLD"
    GREATER_LOWER_LESSER_UPPER_THRESHOLD = "GREATER_LOWER_LESSER_UPPER_THRESHOLD"


class AccelerationSensorMode(Enum):
    ANY_MOTION = "ANY_MOTION"
    FLAT_DECT = "FLAT_DECT"


class AccelerationSensorNeutralPosition(Enum):
    HORIZONTAL = "HORIZONTAL"
    VERTICAL = "VERTICAL"


class AccelerationSensorSensitivity(Enum):
    SENSOR_RANGE_16G = "SENSOR_RANGE_16G"
    SENSOR_RANGE_8G = "SENSOR_RANGE_8G"
    SENSOR_RANGE_4G = "SENSOR_RANGE_4G"
    SENSOR_RANGE_2G = "SENSOR_RANGE_2G"
    SENSOR_RANGE_2G_PLUS_SENS = "SENSOR_RANGE_2G_PLUS_SENS"
    SENSOR_RANGE_2G_2PLUS_SENSE = "SENSOR_RANGE_2G_2PLUS_SENSE"


class NotificationSoundType(Enum):
    SOUND_NO_SOUND = "SOUND_NO_SOUND"
    SOUND_SHORT = "SOUND_SHORT"
    SOUND_SHORT_SHORT = "SOUND_SHORT_SHORT"
    SOUND_LONG = "SOUND_LONG"


class DoorState(Enum):
    CLOSED = "CLOSED"
    OPEN = "OPEN"
    VENTILATION_POSITION = "VENTILATION_POSITION"
    POSITION_UNKNOWN = "POSITION_UNKNOWN"


class DoorCommand(Enum):
    OPEN = "OPEN"
    STOP = "STOP"
    CLOSE = "CLOSE"
    PARTIAL_OPEN = "PARTIAL_OPEN"


class ShadingStateType(Enum):
    NOT_POSSIBLE = "NOT_POSSIBLE"
    NOT_EXISTENT = "NOT_EXISTENT"
    POSITION_USED = "POSITION_USED"
    TILT_USED = "TILT_USED"
    NOT_USED = "NOT_USED"
    MIXED = "MIXED"


class GroupVisibility(Enum):
    INVISIBLE_GROUP_AND_CONTROL = "INVISIBLE_GROUP_AND_CONTROL"
    INVISIBLE_CONTROL = "INVISIBLE_CONTROL"
    VISIBLE = "VISIBLE"


class ProfileMode(Enum):
    AUTOMATIC = "AUTOMATIC"
    MANUAL = "MANUAL"


class AlarmSignalType(Enum):
    NO_ALARM = "NO_ALARM"
    SILENT_ALARM = "SILENT_ALARM"
    FULL_ALARM = "FULL_ALARM"


class ConnectionType(Enum):
    EXTERNAL = "EXTERNAL"
    HMIP_RF = "HMIP_RF"
    HMIP_WIRED = "HMIP_WIRED"
    HMIP_LAN = "HMIP_LAN"
    HMIP_WLAN = "HMIP_WLAN"


class DeviceArchetype(Enum):
    EXTERNAL = "EXTERNAL"
    HMIP = "HMIP"


class DriveSpeed(Enum):
    CREEP_SPEED = "CREEP_SPEED"
    SLOW_SPEED = "SLOW_SPEED"
    NOMINAL_SPEED = "NOMINAL_SPEED"
    OPTIONAL_SPEED = "OPTIONAL_SPEED"


class ShadingPackagePosition(Enum):
    LEFT = "LEFT"
    RIGHT = "RIGHT"
    CENTER = "CENTER"
    SPLIT = "SPLIT"
    TOP = "TOP"
    BOTTOM = "BOTTOM"
    TDBU = "TDBU"
    NOT_USED = "NOT_USED"


class LockState(Enum):
    OPEN = "OPEN"
    UNLOCKED = "UNLOCKED"
    LOCKED = "LOCKED"
    NONE = "NONE"


class MotorState(Enum):
    STOPPED = "STOPPED"
    CLOSING = "CLOSING"
    OPENING = "OPENING"


class OpticalSignalBehaviour(Enum):
    ON = "ON"
    BLINKING_MIDDLE = "BLINKING_MIDDLE"
    FLASH_MIDDLE = "FLASH_MIDDLE"
    BILLOW_MIDDLE = "BILLOW_MIDDLE"
    OFF = "OFF"


class WindowState(Enum):
    OPEN = "OPEN"
    CLOSED = "CLOSED"
    TILTED = "TILTED"


class RGBColorState(Enum):
    BLACK = "BLACK"
    BLUE = "BLUE"
    GREEN = "GREEN"
    TURQUOISE = "TURQUOISE"
    RED = "RED"
    PURPLE = "PURPLE"
    YELLOW = "YELLOW"
    WHITE = "WHITE"


class WindValueType(Enum):
    CURRENT_VALUE = "CURRENT_VALUE"
    MIN_VALUE = "MIN_VALUE"
    MAX_VALUE = "MAX_VALUE"
    AVERAGE_VALUE = "AVERAGE_VALUE"


class AcousticAlarmTiming(Enum):
    PERMANENT = "PERMANENT"
    THREE_MINUTES = "THREE_MINUTES"
    SIX_MINUTES = "SIX_MINUTES"
    ONCE_PER_MINUTE = "ONCE_PER_MINUTE"


class WaterAlarmTrigger(Enum):
    NO_ALARM = "NO_ALARM"
    MOISTURE_DETECTION = "MOISTURE_DETECTION"
    WATER_DETECTION = "WATER_DETECTION"
    WATER_MOISTURE_DETECTION = "WATER_MOISTURE_DETECTION"


class AcousticAlarmSignal(Enum):
    DISABLE_ACOUSTIC_SIGNAL = "DISABLE_ACOUSTIC_SIGNAL"
    FREQUENCY_RISING = "FREQUENCY_RISING"
    FREQUENCY_FALLING = "FREQUENCY_FALLING"
    FREQUENCY_RISING_AND_FALLING = "FREQUENCY_RISING_AND_FALLING"
    FREQUENCY_ALTERNATING_LOW_HIGH = "FREQUENCY_ALTERNATING_LOW_HIGH"
    FREQUENCY_ALTERNATING_LOW_MID_HIGH = "FREQUENCY_ALTERNATING_LOW_MID_HIGH"
    FREQUENCY_HIGHON_OFF = "FREQUENCY_HIGHON_OFF"
    FREQUENCY_HIGHON_LONGOFF = "FREQUENCY_HIGHON_LONGOFF"
    FREQUENCY_LOWON_OFF_HIGHON_OFF = "FREQUENCY_LOWON_OFF_HIGHON_OFF"
    FREQUENCY_LOWON_LONGOFF_HIGHON_LONGOFF = "FREQUENCY_LOWON_LONGOFF_HIGHON_LONGOFF"
    LOW_BATTERY = "LOW_BATTERY"
    DISARMED = "DISARMED"
    INTERNALLY_ARMED = "INTERNALLY_ARMED"
    EXTERNALLY_ARMED = "EXTERNALLY_ARMED"
    DELAYED_INTERNALLY_ARMED = "DELAYED_INTERNALLY_ARMED"
    DELAYED_EXTERNALLY_ARMED = "DELAYED_EXTERNALLY_ARMED"
    EVENT = "EVENT"
    ERROR = "ERROR"


class ClimateControlMode(Enum):
    AUTOMATIC = "AUTOMATIC"
    MANUAL = "MANUAL"
    ECO = "ECO"


class ClimateControlDisplay(Enum):
    ACTUAL = "ACTUAL"
    SETPOINT = "SETPOINT"
    ACTUAL_HUMIDITY = "ACTUAL_HUMIDITY"


class HeatingValveType(Enum):
    NORMALLY_CLOSE = "NORMALLY_CLOSE"
    NORMALLY_OPEN = "NORMALLY_OPEN"


class ValveState(Enum):
    STATE_NOT_AVAILABLE = "STATE_NOT_AVAILABLE"
    RUN_TO_START = "RUN_TO_START"
    WAIT_FOR_ADAPTION = "WAIT_FOR_ADAPTION"
    ADAPTION_IN_PROGRESS = "ADAPTION_IN_PROGRESS"
    ADAPTION_DONE = "ADAPTION_DONE"
    TOO_TIGHT = "TOO_TIGHT"
    ADJUSTMENT_TOO_BIG = "ADJUSTMENT_TOO_BIG"
    ADJUSTMENT_TOO_SMALL = "ADJUSTMENT_TOO_SMALL"
    ERROR_POSITION = "ERROR_POSITION"


class MotionDetectionSendInterval(Enum):
    SECONDS_30 = "SECONDS_30"
    SECONDS_60 = "SECONDS_60"
    SECONDS_120 = "SECONDS_120"
    SECONDS_240 = "SECONDS_240"
    SECONDS_480 = "SECONDS_480"


class SmokeDetectorAlarmType(Enum):
    IDLE_OFF = "IDLE_OFF"
    PRIMARY_ALARM = "PRIMARY_ALARM"
    INTRUSION_ALARM = "INTRUSION_ALARM"
    SECONDARY_ALARM = "SECONDARY_ALARM"


class AlarmContactType(Enum):
    PASSIVE_GLASS_BREAKAGE_DETECTOR = "PASSIVE_GLASS_BREAKAGE_DETECTOR"
    WINDOW_DOOR_CONTACT = "WINDOW_DOOR_CONTACT"


class ContactType(Enum):
    NORMALLY_CLOSE = "NORMALLY_CLOSE"
    NORMALLY_OPEN = "NORMALLY_OPEN"


class HeatingLoadType(Enum):
    LOAD_BALANCING = "LOAD_BALANCING"
    LOAD_COLLECTION = "LOAD_COLLECTION"


from enum import Enum, auto


class DeviceUpdateStrategy(Enum):
    MANUALLY = "MANUALLY"
    AUTOMATICALLY_IF_POSSIBLE = "AUTOMATICALLY_IF_POSSIBLE"


class ApExchangeState(Enum):
    NONE = "NONE"
    REQUESTED = "REQUESTED"
    IN_PROGRESS = "IN_PROGRESS"
    DONE = "DONE"
    REJECTED = "REJECTED"


class HomeUpdateState(Enum):
    UP_TO_DATE = "UP_TO_DATE"
    UPDATE_AVAILABLE = "UPDATE_AVAILABLE"
    PERFORM_UPDATE_SENT = "PERFORM_UPDATE_SENT"
    PERFORMING_UPDATE = "PERFORMING_UPDATE"


class WeatherCondition(Enum):
    CLEAR = "CLEAR"
    LIGHT_CLOUDY = "LIGHT_CLOUDY"
    CLOUDY = "CLOUDY"
    CLOUDY_WITH_RAIN = "CLOUDY_WITH_RAIN"
    CLOUDY_WITH_SNOW_RAIN = "CLOUDY_WITH_SNOW_RAIN"
    HEAVILY_CLOUDY = "HEAVILY_CLOUDY"
    HEAVILY_CLOUDY_WITH_RAIN = "HEAVILY_CLOUDY_WITH_RAIN"
    HEAVILY_CLOUDY_WITH_STRONG_RAIN = "HEAVILY_CLOUDY_WITH_STRONG_RAIN"
    HEAVILY_CLOUDY_WITH_SNOW = "HEAVILY_CLOUDY_WITH_SNOW"
    HEAVILY_CLOUDY_WITH_SNOW_RAIN = "HEAVILY_CLOUDY_WITH_SNOW_RAIN"
    HEAVILY_CLOUDY_WITH_THUNDER = "HEAVILY_CLOUDY_WITH_THUNDER"
    HEAVILY_CLOUDY_WITH_RAIN_AND_THUNDER = "HEAVILY_CLOUDY_WITH_RAIN_AND_THUNDER"
    FOGGY = "FOGGY"
    STRONG_WIND = "STRONG_WIND"
    UNKNOWN = "UNKNOWN"


class WeatherDayTime(Enum):
    DAY = "DAY"
    TWILIGHT = "TWILIGHT"
    NIGHT = "NIGHT"


class FunctionalChannelTypes(Enum):
    """Enum containing all functional channel types."""
    ACCELERATION_SENSOR_CHANNEL = "ACCELERATION_SENSOR_CHANNEL"
    ACCESS_AUTHORIZATION_CHANNEL = "ACCESS_AUTHORIZATION_CHANNEL"
    ACCESS_CONTROLLER_CHANNEL = "ACCESS_CONTROLLER_CHANNEL"
    ACCESS_CONTROLLER_WIRED_CHANNEL = "ACCESS_CONTROLLER_WIRED_CHANNEL"
    ALARM_SIREN_CHANNEL = "ALARM_SIREN_CHANNEL"
    ANALOG_OUTPUT_CHANNEL = "ANALOG_OUTPUT_CHANNEL"
    ANALOG_ROOM_CONTROL_CHANNEL = "ANALOG_ROOM_CONTROL_CHANNEL"
    BLIND_CHANNEL = "BLIND_CHANNEL"
    CARBON_DIOXIDE_SENSOR_CHANNEL = "CARBON_DIOXIDE_SENSOR_CHANNEL"
    CHANGE_OVER_CHANNEL = "CHANGE_OVER_CHANNEL"
    CLIMATE_SENSOR_CHANNEL = "CLIMATE_SENSOR_CHANNEL"
    CONTACT_INTERFACE_CHANNEL = "CONTACT_INTERFACE_CHANNEL"
    DEHUMIDIFIER_DEMAND_CHANNEL = "DEHUMIDIFIER_DEMAND_CHANNEL"
    DEVICE_BASE = "DEVICE_BASE"
    DEVICE_BASE_FLOOR_HEATING = "DEVICE_BASE_FLOOR_HEATING"
    DEVICE_GLOBAL_PUMP_CONTROL = "DEVICE_GLOBAL_PUMP_CONTROL"
    DEVICE_INCORRECT_POSITIONED = "DEVICE_INCORRECT_POSITIONED"
    DEVICE_OPERATIONLOCK = "DEVICE_OPERATIONLOCK"
    DEVICE_OPERATIONLOCK_WITH_SABOTAGE = "DEVICE_OPERATIONLOCK_WITH_SABOTAGE"
    DEVICE_PERMANENT_FULL_RX = "DEVICE_PERMANENT_FULL_RX"
    DEVICE_RECHARGEABLE_WITH_SABOTAGE = "DEVICE_RECHARGEABLE_WITH_SABOTAGE"
    DEVICE_SABOTAGE = "DEVICE_SABOTAGE"
    DIMMER_CHANNEL = "DIMMER_CHANNEL"
    DOOR_CHANNEL = "DOOR_CHANNEL"
    DOOR_LOCK_CHANNEL = "DOOR_LOCK_CHANNEL"
    DOOR_LOCK_SENSOR_CHANNEL = "DOOR_LOCK_SENSOR_CHANNEL"
    ENERGY_SENSORS_INTERFACE_CHANNEL = "ENERGY_SENSORS_INTERFACE_CHANNEL"
    EXTERNAL_BASE_CHANNEL = "EXTERNAL_BASE_CHANNEL"
    EXTERNAL_UNIVERSAL_LIGHT_CHANNEL = "EXTERNAL_UNIVERSAL_LIGHT_CHANNEL"
    FLOOR_TERMINAL_BLOCK_CHANNEL = "FLOOR_TERMINAL_BLOCK_CHANNEL"
    FLOOR_TERMINAL_BLOCK_LOCAL_PUMP_CHANNEL = "FLOOR_TERMINAL_BLOCK_LOCAL_PUMP_CHANNEL"
    FLOOR_TERMINAL_BLOCK_MECHANIC_CHANNEL = "FLOOR_TERMINAL_BLOCK_MECHANIC_CHANNEL"
    GENERIC_INPUT_CHANNEL = "GENERIC_INPUT_CHANNEL"
    HEATING_THERMOSTAT_CHANNEL = "HEATING_THERMOSTAT_CHANNEL"
    HEAT_DEMAND_CHANNEL = "HEAT_DEMAND_CHANNEL"
    IMPULSE_OUTPUT_CHANNEL = "IMPULSE_OUTPUT_CHANNEL"
    INTERNAL_SWITCH_CHANNEL = "INTERNAL_SWITCH_CHANNEL"
    LIGHT_SENSOR_CHANNEL = "LIGHT_SENSOR_CHANNEL"
    MAINS_FAILURE_CHANNEL = "MAINS_FAILURE_CHANNEL"
    MOTION_DETECTION_CHANNEL = "MOTION_DETECTION_CHANNEL"
    MULTI_MODE_INPUT_BLIND_CHANNEL = "MULTI_MODE_INPUT_BLIND_CHANNEL"
    MULTI_MODE_INPUT_CHANNEL = "MULTI_MODE_INPUT_CHANNEL"
    MULTI_MODE_INPUT_DIMMER_CHANNEL = "MULTI_MODE_INPUT_DIMMER_CHANNEL"
    MULTI_MODE_INPUT_SWITCH_CHANNEL = "MULTI_MODE_INPUT_SWITCH_CHANNEL"
    NOTIFICATION_LIGHT_CHANNEL = "NOTIFICATION_LIGHT_CHANNEL"
    OPTICAL_SIGNAL_CHANNEL = "OPTICAL_SIGNAL_CHANNEL"
    OPTICAL_SIGNAL_GROUP_CHANNEL = "OPTICAL_SIGNAL_GROUP_CHANNEL"
    PASSAGE_DETECTOR_CHANNEL = "PASSAGE_DETECTOR_CHANNEL"
    PRESENCE_DETECTION_CHANNEL = "PRESENCE_DETECTION_CHANNEL"
    RAIN_DETECTION_CHANNEL = "RAIN_DETECTION_CHANNEL"
    ROTARY_HANDLE_CHANNEL = "ROTARY_HANDLE_CHANNEL"
    SHADING_CHANNEL = "SHADING_CHANNEL"
    SHUTTER_CHANNEL = "SHUTTER_CHANNEL"
    SHUTTER_CONTACT_CHANNEL = "SHUTTER_CONTACT_CHANNEL"
    SINGLE_KEY_CHANNEL = "SINGLE_KEY_CHANNEL"
    SMOKE_DETECTOR_CHANNEL = "SMOKE_DETECTOR_CHANNEL"
    SWITCH_CHANNEL = "SWITCH_CHANNEL"
    SWITCH_MEASURING_CHANNEL = "SWITCH_MEASURING_CHANNEL"
    TEMPERATURE_SENSOR_2_EXTERNAL_DELTA_CHANNEL = "TEMPERATURE_SENSOR_2_EXTERNAL_DELTA_CHANNEL"
    TILT_VIBRATION_SENSOR_CHANNEL = "TILT_VIBRATION_SENSOR_CHANNEL"
    UNIVERSAL_LIGHT_CHANNEL = "UNIVERSAL_LIGHT_CHANNEL"
    UNIVERSAL_LIGHT_GROUP_CHANNEL = "UNIVERSAL_LIGHT_GROUP_CHANNEL"
    WALL_MOUNTED_THERMOSTAT_PRO_CHANNEL = "WALL_MOUNTED_THERMOSTAT_PRO_CHANNEL"
    WATER_SENSOR_CHANNEL = "WATER_SENSOR_CHANNEL"
    WEATHER_SENSOR_CHANNEL = "WEATHER_SENSOR_CHANNEL"
    WEATHER_SENSOR_PLUS_CHANNEL = "WEATHER_SENSOR_PLUS_CHANNEL"
    WEATHER_SENSOR_PRO_CHANNEL = "WEATHER_SENSOR_PRO_CHANNEL"
